# TCL for Announcing ServerEvents and Public commands into IRC 
# This script runs if the bot receives a HUP-Signal 
# So the Site has to send the Bot a HUP if theres something to announce 
# 
#
#  I didnt write the original one, and I dont know who did, but I severly 
#  modified to the point it looks nothing like the original :)
#                      topace
#
# modify ALL of the following variables to suit your needs

set ANNOUNCEFILE "/home/openftpd/etc/announce.txt"
set CHANNEL "#openftpd"
set PEOPLE ""
set trigger "!site"
set sitebot "/home/openftpd/bin/sitebot.pl"
set shortsitename "SITE"
set nfodir "/home/openftpd/nfo/"
set linebreakval 250

##############  SHOULDNT HAVE TO CHANGE ANYTHING PAST HERE!! #################

global botnick

proc fixStr {who text} {
  global shortsitename CHANNEL sitebot linebreakval

  set string1 $text
  set strilen [string length $string1]

  if { $strilen >= $linebreakval } {
      set loop 1
      set num 0
      set temp $string1

      while { $loop == 1 } {
            if {[string length $temp] < $linebreakval } {
                 set loop 0
            }

            set idx [string last " " [string range $temp 0 $linebreakval]]
            if { $idx > 0 } {
                 lappend out [string range $temp 0 [expr $idx-1]]
                 set temp [string range $temp $idx $strilen]
            } else {
                 lappend out [string range $temp 0 [expr $linebreakval-1]]
                 set temp [string range $temp $linebreakval $strilen]
            }
      }
      foreach txt $out { putserv "PRIVMSG $who :$txt" }
  } else {
      putserv "PRIVMSG $who :$text"
  }
}

# lets check if there is something to announce ...
if {[file exists $ANNOUNCEFILE]==1} {
  #open file for reading
  set f [open $ANNOUNCEFILE r]
  #and loop through the file
  while {[gets $f line] >= 0} {
      #we announce every line to channels
      #foreach chan $CHANNEL {putserv "PRIVMSG $chan :$line"}
      foreach chan $CHANNEL {fixStr $chan $line}
      #and to several people
      #foreach person $PEOPLE {putserv "PRIVMSG $person :$line"}
      foreach person $PEOPLE {fixStr $person $line}
  }
  close $f
  #announcing done - now remove the file
  exec rm $ANNOUNCEFILE
}

#sitebot command for dccinfo

### use this line for !sitenfo
#bind pub -|- [set trigger]nfo pub_nfo     

### use this line for !nfo
bind pub -|- !nfo pub_nfo     
proc pub_nfo {nick host handle channel text} {
	global nfodir CHANNEL
	if [file exists "$nfodir$text"] {
		if [string match "*nfo" $text] {
			dccsend $nfodir$text $nick
			putserv "NOTICE $channel :$text was sent to $nick"
		} else {
			putserv "NOTICE $channel :$nick tried to get a non .nfo file!"
		}
	} else {
		putserv "NOTICE $channel :$nick the file you requested does not exist"
	}
}


#sitebot command, for public commands via eggdrop
bind pub - $trigger pub_sitebot
proc pub_sitebot {nick host handle channel text} {
  global shortsitename CHANNEL sitebot
  set sitebotcmd [lindex $text 0]
  set option1 [lindex $text 1]
  set option2 [lindex $text 2]
  set option3 [lindex $text 3]
  set option4 [lindex $text 4]
  set alloptions "chan $sitebotcmd $option1 $option2 $option3 $option4"
  set result [exec $sitebot $alloptions]
  #putchan $channel "$result"
  foreach {l} [split $result \n] {fixStr $channel $l}
}

#sitebot command, for messaged commands via eggdrop
bind msg - $trigger msg_sitebot
proc msg_sitebot {nick host handle text} {
  global shortsitename CHANNEL sitebot
  set sitebotcmd [lindex $text 0]
  set option1 [lindex $text 1]
  set option2 [lindex $text 2]
  set option3 [lindex $text 3]
  set option4 [lindex $text 4]
  set alloptions "msg $sitebotcmd $option1 $option2 $option3 $option4"
  set result [exec $sitebot $alloptions]
  #foreach {l} [split $result \n] { putserv "PRIVMSG $nick :$l" }
  foreach {l} [split $result \n] {fixStr $nick $l}
}

#test for linebreaks
bind msg - !test fix_string_lengths
proc fix_string_lengths {nick host handle text} {
  global shortsitename CHANNEL sitebot linebreakval

  set string1 $text
  set strilen [string length $string1]

  if { $strilen >= $linebreakval } {
      set loop 1
      set num 0
      set temp $string1

      while { $loop == 1 } {

            if {[string length $temp] < $linebreakval } {
                 set loop 0
            }

            set idx [string last " " [string range $temp 0 $linebreakval]]
            if { $idx > 0 } {
                 lappend out [string range $temp 0 [expr $idx-1]]
                 set temp [string range $temp $idx $strilen]
            } else {
                 lappend out [string range $temp 0 [expr $linebreakval-1]]
                 set temp [string range $temp $linebreakval $strilen]
            }
      }
      foreach txt $out { putserv "PRIVMSG $nick :$txt" }
  } else {
      putserv "PRIVMSG $nick :$text"
  }
}


putlog "OpenFTPD Sitebot Loaded"
