/*   ftpd.h
 *
 *   This file is part of FTP4ALL
 *
 *   Copyright (C) 1996-1999 by Crescent
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

int get_socket(int type, int port, int queue, struct sockaddr_in* addr);
int srv_accept(int fd, void* ptr);
int shandler_add(int fd, void* ptr, int (*handler)(int,void*));
void shandler_del(int fd);
void update_children_shandler(struct child_s* c_old, struct child_s* c_new);
int in_idents(unsigned long ip, char* ident);

/* EOF */
